//  yuv2nv12.cpp
//
//	YUV to NV12 converter
//
//	Copyright (c) 2005 N099
//

#define WIN32_LEAN_AND_MEAN // Windows wb_[gpĂȂO܂B
// Windows wb_[ t@C :
#include <windows.h>

#include <streams.h>
#include <dvdmedia.h>
#include <aviriff.h> 
#include <initguid.h>
#include "defs.h"
#include "reg.h"
#include "yuv2nv12.h"
#include "cnv_func.h"


extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);
BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
	return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}


//constructor
Cyuv2nv12::Cyuv2nv12(TCHAR *tszName, LPUNKNOWN punk)
	: CTransformFilter(tszName, punk, CLSID_YUV2NV12)
{ 
	interlace = format_in = 0;
	height = width_in = width_in_s = width_out = width_out_s = 0;
	LoadRegistryInfo(&conf);
	if(!isMMXavailable())
		conf.use_mmx = 0;
}

//CreateInstance
CUnknown *Cyuv2nv12::CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr)
{
	Cyuv2nv12 *pFilter = new Cyuv2nv12(NAME("YUV to NV12 converter"), pUnk);
	if (pFilter== NULL) 
	{
		*pHr = E_OUTOFMEMORY;
	}
	return pFilter;
}


//͂̃`FbN
HRESULT Cyuv2nv12::CheckInputType(const CMediaType *mtIn)
{
	if(mtIn->majortype != MEDIATYPE_Video){
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	BITMAPINFOHEADER *pbmi;
	if(mtIn->formattype == FORMAT_VideoInfo && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmi = &reinterpret_cast<VIDEOINFOHEADER*>(mtIn->Format())->bmiHeader;
	}else if(mtIn->formattype == FORMAT_VideoInfo2 && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2)){
		pbmi = &reinterpret_cast<VIDEOINFOHEADER2*>(mtIn->Format())->bmiHeader;
	}else{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	//J[tH[}bg̃`FbN
	if(mtIn->subtype == MEDIASUBTYPE_YV12){
		if(pbmi->biCompression != FCC('YV12'))
			return VFW_E_TYPE_NOT_ACCEPTED;

	}else if(mtIn->subtype == MEDIASUBTYPE_YUY2){
		if(pbmi->biCompression != FCC('YUY2'))
			return VFW_E_TYPE_NOT_ACCEPTED;

	}else{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}


	// ׂĖȂB
	return S_OK;
}

//o͌`̒
HRESULT Cyuv2nv12::GetMediaType(int iPosition, CMediaType *pMediaType)
{
	ASSERT(m_pInput->IsConnected());
	if (iPosition < 0)
	{
		return E_INVALIDARG;
	}
	if (iPosition == 0)
	{
		HRESULT hr;
		hr = m_pInput->ConnectionMediaType(pMediaType);
		if (FAILED(hr))
		{
			return hr;
		}
		pMediaType->subtype = MEDIASUBTYPE_NV12;

		//BITMAPINFOHEADERł̃^Cvw
		BITMAPINFOHEADER *pbmi;
		if (pMediaType->formattype == FORMAT_VideoInfo && pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER))
		{
			pbmi = &reinterpret_cast<VIDEOINFOHEADER*>(pMediaType->Format())->bmiHeader;
		}
		else if (pMediaType->formattype == FORMAT_VideoInfo2 && pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER2))
		{
			pbmi = &reinterpret_cast<VIDEOINFOHEADER2*>(pMediaType->Format())->bmiHeader;
		}
		else
		{
			return E_UNEXPECTED;
		}

		long h = abs(pbmi->biHeight);
		pbmi->biCompression = FCC('NV12');
		pbmi->biBitCount = 12;
		pbmi->biSizeImage = pbmi->biWidth * (h + ((h+1)>>1));

		return S_OK;
	}
	// else
	return VFW_S_NO_MORE_ITEMS;
}

//ڑ̃`FbN
HRESULT Cyuv2nv12::CheckTransform(
    const CMediaType *mtIn, const CMediaType *mtOut)
{
	BITMAPINFOHEADER *pbmiIn, *pbmiOut;
	RECT *prcSrc, *prcTarget;

	if (mtIn->formattype == FORMAT_VideoInfo && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER))
	{
		pbmiIn = &reinterpret_cast<VIDEOINFOHEADER*>(mtIn->pbFormat)->bmiHeader;
		prcSrc = &reinterpret_cast<VIDEOINFOHEADER*>(mtIn->pbFormat)->rcSource;
	}
	else if (mtIn->formattype == FORMAT_VideoInfo2 && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2))
	{
		pbmiIn = &reinterpret_cast<VIDEOINFOHEADER2*>(mtIn->pbFormat)->bmiHeader;
		prcSrc = &reinterpret_cast<VIDEOINFOHEADER2*>(mtIn->pbFormat)->rcSource;
	}else{
		return E_UNEXPECTED;
	}

	if (mtOut->formattype == FORMAT_VideoInfo && mtOut->cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmiOut   = &reinterpret_cast<VIDEOINFOHEADER*>(mtOut->Format())->bmiHeader;
		prcTarget = &reinterpret_cast<VIDEOINFOHEADER*>(mtOut->Format())->rcTarget;
	}
	else if (mtOut->formattype == FORMAT_VideoInfo2 && mtOut->cbFormat >= sizeof(VIDEOINFOHEADER2)){
		pbmiOut   = &reinterpret_cast<VIDEOINFOHEADER2*>(mtOut->Format())->bmiHeader;
		prcTarget = &reinterpret_cast<VIDEOINFOHEADER2*>(mtOut->Format())->rcTarget;
	}else{
		return E_UNEXPECTED;
	}
	//biWidth̓XgCh̒l
	width_out_s = pbmiOut->biWidth;
	width_in_s  = pbmiIn->biWidth;
	long height_out = abs(pbmiOut->biHeight);
	long height_in  = abs(pbmiIn->biHeight);

	//قȂ邱Ƃ͂肦ȂEE
	if (height_out != height_in) {
		return VFW_E_INVALIDMEDIATYPE;
	}else{
		height = height_in;
	}

	// ]`Ɠ]`rB
	// ܂Ӗ킩ĂȂB
	RECT rcImg;
	SetRect(&rcImg, 0, 0, width_in_s, height);
	if (IsRectEmpty(prcSrc) || EqualRect(prcSrc, &rcImg)) {
		// XgChlȂĂ悢ꍇ
		width_in = width_in_s;
	} else {
		RECT rcImg2 = rcImg;
		rcImg2.right = prcSrc->right;
		// ̓f[^̃XgChl
		if(!EqualRect(prcSrc, &rcImg2) || rcImg2.right>width_in_s) {
			return VFW_E_INVALIDMEDIATYPE;
		}
		width_in = rcImg2.right;
	}

	SetRect(&rcImg, 0, 0, width_out_s, height);
	if (IsRectEmpty(prcTarget) || EqualRect(prcTarget, &rcImg)) {
		width_out = width_out_s;
	} else {
		RECT rcImg2 = rcImg;
		rcImg2.right = prcTarget->right;
		// o̓f[^̃XgChl
		if(!EqualRect(prcTarget, &rcImg2) || rcImg2.right>width_out_s) {
			return VFW_E_INVALIDMEDIATYPE;
		}
		width_out = rcImg2.right;
	}

	//o͉摜̕ꉞ`FbN
	if (width_out != width_in) {
		return VFW_E_INVALIDMEDIATYPE;
	}

	//̓tH[}bgݒ
	format_in = 0;
	if(mtIn->subtype == MEDIASUBTYPE_YV12){
		if(pbmiIn->biCompression == FCC('YV12'))
			format_in = FMT_YV12;
	}else if(mtIn->subtype == MEDIASUBTYPE_YUY2){
		if(pbmiIn->biCompression == FCC('YUY2'))
			format_in = FMT_YUY2;
	}
	if(0 == format_in){
		return VFW_E_TYPE_NOT_ACCEPTED;
	}


	// ׂĖȂB
	return S_OK;
}

//CompleteConnect
HRESULT Cyuv2nv12::CompleteConnect(PIN_DIRECTION direction,IPin *pReceivePin)
{
	UNREFERENCED_PARAMETER(direction);
	UNREFERENCED_PARAMETER(pReceivePin);

	if(direction == PINDIR_INPUT && 0 == conf.connect_nv12){
		//㗬tB^NV12o͂ɑΉĂꍇ͐ڑȂ
		HRESULT hr;
		IEnumMediaTypes *pEnum = NULL;
		BOOL nv12 = false;

		hr = pReceivePin->EnumMediaTypes(&pEnum);
		if(S_OK == hr){
			AM_MEDIA_TYPE *pamt = NULL;
			while(1){
				hr = pEnum->Next(1, &pamt, NULL);
				if(S_OK == hr){
					if(pamt->subtype == MEDIASUBTYPE_NV12){
						nv12 = true;
						DeleteMediaType(pamt);
						break;
					}
					DeleteMediaType(pamt);
					pamt = NULL;
				}else if(VFW_E_ENUM_OUT_OF_SYNC == hr){
					pEnum->Reset();
				}else{
					break;
				}
			}
			pEnum->Release();
		}

		if(nv12) return E_FAIL;
	}

	return NOERROR;
}


HRESULT Cyuv2nv12::DecideBufferSize(
    IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pProp)
{
	AM_MEDIA_TYPE mt;
	HRESULT hr = m_pOutput->ConnectionMediaType(&mt);
	if (FAILED(hr))
	{
		return hr;
	}

	//BITMAPINFOHEADERTCY𓾂
	BITMAPINFOHEADER *pbmi;
	if (mt.formattype == FORMAT_VideoInfo && mt.cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmi = &reinterpret_cast<VIDEOINFOHEADER*>(mt.pbFormat)->bmiHeader;
	} else if (mt.formattype == FORMAT_VideoInfo2 && mt.cbFormat >= sizeof(VIDEOINFOHEADER2)) {
		pbmi = &reinterpret_cast<VIDEOINFOHEADER2*>(mt.pbFormat)->bmiHeader;
	} else {
		//ɂ͗Ȃ
		return E_UNEXPECTED;
	}
	//őH
	pProp->cbBuffer = DIBSIZE(*pbmi); 
	if (pProp->cbAlign == 0)
	{
		pProp->cbAlign = 1;
	}
	if (pProp->cBuffers == 0)
	{
		pProp->cBuffers = 1;
	}
	// tH[}bg ubNB
	FreeMediaType(mt);

	// AP[^ vpeBݒ肷B
	ALLOCATOR_PROPERTIES Actual;
	hr = pAlloc->SetProperties(pProp, &Actual);
	if (FAILED(hr)) 
	{
		return hr;
	}
	// ꍇAۂ̌ʂmFB
	if (pProp->cbBuffer > Actual.cbBuffer) 
	{
		return E_FAIL;
	}
	return S_OK;
}

//ۂ̕ϊ
HRESULT Cyuv2nv12::Transform(IMediaSample *pSource, IMediaSample *pDest)
{
	// _EXg[̃tH[}bgύXB
	CMediaType *pMT = NULL;
	HRESULT hr = pDest->GetMediaType((AM_MEDIA_TYPE**)&pMT);
	if (hr == S_OK)
	{
		hr = m_pOutput->CheckMediaType(pMT);
		if(FAILED(hr))
		{
			DeleteMediaType(pMT);
			return E_FAIL;
		}
		// V^CvɂĎg̏o̓sɒʒmB
		m_pOutput->SetMediaType(pMT);
		DeleteMediaType(pMT);
	}

	// ɂȂobt@ւ̃|C^擾B
	BYTE *pBufferIn, *pBufferOut;
	hr = pSource->GetPointer(&pBufferIn);
	if (FAILED(hr))
	{
		return hr;
	}
	hr = pDest->GetPointer(&pBufferOut);
	if (FAILED(hr))
	{
		return hr;
	}

    // f[^B
	//CopyMemory(pBufferOut, pBufferIn, pSource->GetSize());
	if(format_in == FMT_YV12){
		if(conf.use_mmx){
			mmx_yv12_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
		}else{
			yv12_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
		}
	}else if(format_in == FMT_YUY2){
		CheckInterlace(pSource);
		if(interlace){ //C^
			if(conf.i_sample_pos){ //FTvʒu:S
				if(conf.use_mmx)
					mmx_ix_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
				else
					ix_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
			}else{ //FTvʒu:MPEG2
				if(conf.use_mmx)
					mmx_i_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
				else
					i_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
			}
		}else{ //vO
			if(conf.use_mmx)
				mmx_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
			else
				yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
		}
	}

	//ۂ̃f[^ʒm
	pDest->SetActualDataLength((width_out_s + ((width_out_s + 1) >> 1)) * height);
	//L[t[łB
	pDest->SetSyncPoint(TRUE);

	return S_OK;
}

//C^[[X/vObVu̔
HRESULT Cyuv2nv12::CheckInterlace(IMediaSample *pSource)
{
	// I/P
	if(conf.mode_ip){
		// I/PŒ
		interlace = conf.mode_ip >> 1;
	}else{
		// I/Pݒ
		interlace = 0;
		if(FORMAT_VideoInfo2 == m_pInput->CurrentMediaType().formattype
			&& m_pInput->CurrentMediaType().cbFormat >= sizeof(VIDEOINFOHEADER2))
		{
			VIDEOINFOHEADER2 *vif2 = 
				reinterpret_cast<VIDEOINFOHEADER2*>(m_pInput->CurrentMediaType().pbFormat);
			if(AMINTERLACE_IsInterlaced & vif2->dwInterlaceFlags){
				interlace = 1;
				//C^[[XtO`FbNAM_SAMPLE2_PROPERTIES𒲂ׂ
				IMediaSample2 *pIm2 = NULL;
				HRESULT hr = pSource->QueryInterface(IID_IMediaSample2, (void**)&pIm2);
				if(SUCCEEDED(hr)){
					AM_SAMPLE2_PROPERTIES am2;
					hr = pIm2->GetProperties(offsetof(AM_SAMPLE2_PROPERTIES, dwSampleFlags), (BYTE*)&am2);
					if(SUCCEEDED(hr)){
						if(am2.dwTypeSpecificFlags & AM_VIDEO_FLAG_WEAVE)
							interlace = 0;
					}
					pIm2->Release();
				}
			}
		}
	}

	return S_OK;
}

//tB^̓o^
STDAPI DllRegisterServer(void)
{
	HRESULT hr = AMovieDllRegisterServer2(TRUE);
	if (FAILED(hr))
	{
		return hr;
	}
	IFilterMapper2 *pFM2 = NULL;
	hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
						IID_IFilterMapper2, (void **)&pFM2);
	if (SUCCEEDED(hr))
	{
		hr = pFM2->RegisterFilter(
			CLSID_YUV2NV12,           // tB^ CLSIDB
			g_wszName,                       // tB^B
			NULL,                            // foCX jJB
			&CLSID_LegacyAmFilterCategory,   // Dsf
			NULL,                       // CX^X f[^B
			&rf2FilterReg                    // tB^B
		);
		pFM2->Release();
	}
	return hr;
}

//tB^̓o^
STDAPI DllUnregisterServer()
{
	HRESULT hr = AMovieDllRegisterServer2(FALSE);
	if (FAILED(hr))
	{
		return hr;
	}
	IFilterMapper2 *pFM2 = NULL;
	hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
			IID_IFilterMapper2, (void **)&pFM2);
	if (SUCCEEDED(hr))
	{
		hr = pFM2->UnregisterFilter(&CLSID_LegacyAmFilterCategory, 
			NULL, CLSID_YUV2NV12);
		pFM2->Release();
	}
	return hr;
}



